/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the WebhookEvent type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebhookEvent{}

// WebhookEvent struct for WebhookEvent
type WebhookEvent struct {
	Id string `json:"id"`
	TransactionId string `json:"transaction_id"`
	Type WebhookEventType `json:"type"`
	ChannelId string `json:"channel_id"`
	Contact *WebhookEventContact `json:"contact,omitempty"`
	ComChannel *WebhookEventComChannel `json:"com_channel,omitempty"`
	Conversation *WebhookEventConversation `json:"conversation,omitempty"`
	Gateway *WebhookEventGateway `json:"gateway,omitempty"`
	Script *WebhookEventScript `json:"script,omitempty"`
	MessageStatus *WebhookEventMessageStatus `json:"message_status,omitempty"`
	Message *WebhookEventMessage `json:"message,omitempty"`
	Timestamp time.Time `json:"timestamp"`
}

// NewWebhookEvent instantiates a new WebhookEvent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebhookEvent(id string, transactionId string, type_ WebhookEventType, channelId string, timestamp time.Time) *WebhookEvent {
	this := WebhookEvent{}
	this.Id = id
	this.TransactionId = transactionId
	this.Type = type_
	this.ChannelId = channelId
	this.Timestamp = timestamp
	return &this
}

// NewWebhookEventWithDefaults instantiates a new WebhookEvent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebhookEventWithDefaults() *WebhookEvent {
	this := WebhookEvent{}
	return &this
}

// GetId returns the Id field value
func (o *WebhookEvent) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WebhookEvent) SetId(v string) {
	o.Id = v
}

// GetTransactionId returns the TransactionId field value
func (o *WebhookEvent) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *WebhookEvent) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetType returns the Type field value
func (o *WebhookEvent) GetType() WebhookEventType {
	if o == nil {
		var ret WebhookEventType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetTypeOk() (*WebhookEventType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *WebhookEvent) SetType(v WebhookEventType) {
	o.Type = v
}

// GetChannelId returns the ChannelId field value
func (o *WebhookEvent) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *WebhookEvent) SetChannelId(v string) {
	o.ChannelId = v
}

// GetContact returns the Contact field value if set, zero value otherwise.
func (o *WebhookEvent) GetContact() WebhookEventContact {
	if o == nil || IsNil(o.Contact) {
		var ret WebhookEventContact
		return ret
	}
	return *o.Contact
}

// GetContactOk returns a tuple with the Contact field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetContactOk() (*WebhookEventContact, bool) {
	if o == nil || IsNil(o.Contact) {
		return nil, false
	}
	return o.Contact, true
}

// HasContact returns a boolean if a field has been set.
func (o *WebhookEvent) HasContact() bool {
	if o != nil && !IsNil(o.Contact) {
		return true
	}

	return false
}

// SetContact gets a reference to the given WebhookEventContact and assigns it to the Contact field.
func (o *WebhookEvent) SetContact(v WebhookEventContact) {
	o.Contact = &v
}

// GetComChannel returns the ComChannel field value if set, zero value otherwise.
func (o *WebhookEvent) GetComChannel() WebhookEventComChannel {
	if o == nil || IsNil(o.ComChannel) {
		var ret WebhookEventComChannel
		return ret
	}
	return *o.ComChannel
}

// GetComChannelOk returns a tuple with the ComChannel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetComChannelOk() (*WebhookEventComChannel, bool) {
	if o == nil || IsNil(o.ComChannel) {
		return nil, false
	}
	return o.ComChannel, true
}

// HasComChannel returns a boolean if a field has been set.
func (o *WebhookEvent) HasComChannel() bool {
	if o != nil && !IsNil(o.ComChannel) {
		return true
	}

	return false
}

// SetComChannel gets a reference to the given WebhookEventComChannel and assigns it to the ComChannel field.
func (o *WebhookEvent) SetComChannel(v WebhookEventComChannel) {
	o.ComChannel = &v
}

// GetConversation returns the Conversation field value if set, zero value otherwise.
func (o *WebhookEvent) GetConversation() WebhookEventConversation {
	if o == nil || IsNil(o.Conversation) {
		var ret WebhookEventConversation
		return ret
	}
	return *o.Conversation
}

// GetConversationOk returns a tuple with the Conversation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetConversationOk() (*WebhookEventConversation, bool) {
	if o == nil || IsNil(o.Conversation) {
		return nil, false
	}
	return o.Conversation, true
}

// HasConversation returns a boolean if a field has been set.
func (o *WebhookEvent) HasConversation() bool {
	if o != nil && !IsNil(o.Conversation) {
		return true
	}

	return false
}

// SetConversation gets a reference to the given WebhookEventConversation and assigns it to the Conversation field.
func (o *WebhookEvent) SetConversation(v WebhookEventConversation) {
	o.Conversation = &v
}

// GetGateway returns the Gateway field value if set, zero value otherwise.
func (o *WebhookEvent) GetGateway() WebhookEventGateway {
	if o == nil || IsNil(o.Gateway) {
		var ret WebhookEventGateway
		return ret
	}
	return *o.Gateway
}

// GetGatewayOk returns a tuple with the Gateway field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetGatewayOk() (*WebhookEventGateway, bool) {
	if o == nil || IsNil(o.Gateway) {
		return nil, false
	}
	return o.Gateway, true
}

// HasGateway returns a boolean if a field has been set.
func (o *WebhookEvent) HasGateway() bool {
	if o != nil && !IsNil(o.Gateway) {
		return true
	}

	return false
}

// SetGateway gets a reference to the given WebhookEventGateway and assigns it to the Gateway field.
func (o *WebhookEvent) SetGateway(v WebhookEventGateway) {
	o.Gateway = &v
}

// GetScript returns the Script field value if set, zero value otherwise.
func (o *WebhookEvent) GetScript() WebhookEventScript {
	if o == nil || IsNil(o.Script) {
		var ret WebhookEventScript
		return ret
	}
	return *o.Script
}

// GetScriptOk returns a tuple with the Script field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetScriptOk() (*WebhookEventScript, bool) {
	if o == nil || IsNil(o.Script) {
		return nil, false
	}
	return o.Script, true
}

// HasScript returns a boolean if a field has been set.
func (o *WebhookEvent) HasScript() bool {
	if o != nil && !IsNil(o.Script) {
		return true
	}

	return false
}

// SetScript gets a reference to the given WebhookEventScript and assigns it to the Script field.
func (o *WebhookEvent) SetScript(v WebhookEventScript) {
	o.Script = &v
}

// GetMessageStatus returns the MessageStatus field value if set, zero value otherwise.
func (o *WebhookEvent) GetMessageStatus() WebhookEventMessageStatus {
	if o == nil || IsNil(o.MessageStatus) {
		var ret WebhookEventMessageStatus
		return ret
	}
	return *o.MessageStatus
}

// GetMessageStatusOk returns a tuple with the MessageStatus field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetMessageStatusOk() (*WebhookEventMessageStatus, bool) {
	if o == nil || IsNil(o.MessageStatus) {
		return nil, false
	}
	return o.MessageStatus, true
}

// HasMessageStatus returns a boolean if a field has been set.
func (o *WebhookEvent) HasMessageStatus() bool {
	if o != nil && !IsNil(o.MessageStatus) {
		return true
	}

	return false
}

// SetMessageStatus gets a reference to the given WebhookEventMessageStatus and assigns it to the MessageStatus field.
func (o *WebhookEvent) SetMessageStatus(v WebhookEventMessageStatus) {
	o.MessageStatus = &v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *WebhookEvent) GetMessage() WebhookEventMessage {
	if o == nil || IsNil(o.Message) {
		var ret WebhookEventMessage
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetMessageOk() (*WebhookEventMessage, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *WebhookEvent) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given WebhookEventMessage and assigns it to the Message field.
func (o *WebhookEvent) SetMessage(v WebhookEventMessage) {
	o.Message = &v
}

// GetTimestamp returns the Timestamp field value
func (o *WebhookEvent) GetTimestamp() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value
// and a boolean to check if the value has been set.
func (o *WebhookEvent) GetTimestampOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Timestamp, true
}

// SetTimestamp sets field value
func (o *WebhookEvent) SetTimestamp(v time.Time) {
	o.Timestamp = v
}

func (o WebhookEvent) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebhookEvent) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["type"] = o.Type
	toSerialize["channel_id"] = o.ChannelId
	if !IsNil(o.Contact) {
		toSerialize["contact"] = o.Contact
	}
	if !IsNil(o.ComChannel) {
		toSerialize["com_channel"] = o.ComChannel
	}
	if !IsNil(o.Conversation) {
		toSerialize["conversation"] = o.Conversation
	}
	if !IsNil(o.Gateway) {
		toSerialize["gateway"] = o.Gateway
	}
	if !IsNil(o.Script) {
		toSerialize["script"] = o.Script
	}
	if !IsNil(o.MessageStatus) {
		toSerialize["message_status"] = o.MessageStatus
	}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	toSerialize["timestamp"] = o.Timestamp
	return toSerialize, nil
}

type NullableWebhookEvent struct {
	value *WebhookEvent
	isSet bool
}

func (v NullableWebhookEvent) Get() *WebhookEvent {
	return v.value
}

func (v *NullableWebhookEvent) Set(val *WebhookEvent) {
	v.value = val
	v.isSet = true
}

func (v NullableWebhookEvent) IsSet() bool {
	return v.isSet
}

func (v *NullableWebhookEvent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebhookEvent(val *WebhookEvent) *NullableWebhookEvent {
	return &NullableWebhookEvent{value: val, isSet: true}
}

func (v NullableWebhookEvent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebhookEvent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


